

public class Parser {
	public static final int _EOF = 0;
	public static final int _name = 1;
	public static final int _nameabbr = 2;
	public static final int _number = 3;
	public static final int maxT = 12;

	static final boolean T = true;
	static final boolean x = false;
	static final int minErrDist = 2;

	public Token t;    // last recognized token
	public Token la;   // lookahead token
	int errDist = minErrDist;
	
	public Scanner scanner;
	public Errors errors;

	

	public Parser(Scanner scanner) {
		this.scanner = scanner;
		errors = new Errors();
	}

	void SynErr (int n) {
		if (errDist >= minErrDist) errors.SynErr(la.line, la.col, n);
		errDist = 0;
	}

	public void SemErr (String msg) {
		if (errDist >= minErrDist) errors.SemErr(t.line, t.col, msg);
		errDist = 0;
	}
	
	void Get () {
		for (;;) {
			t = la;
			la = scanner.Scan();
			if (la.kind <= maxT) {
				++errDist;
				break;
			}

			la = t;
		}
	}
	
	void Expect (int n) {
		if (la.kind==n) Get(); else { SynErr(n); }
	}
	
	boolean StartOf (int s) {
		return set[s][la.kind];
	}
	
	void ExpectWeak (int n, int follow) {
		if (la.kind == n) Get();
		else {
			SynErr(n);
			while (!StartOf(follow)) Get();
		}
	}
	
	boolean WeakSeparator (int n, int syFol, int repFol) {
		int kind = la.kind;
		if (kind == n) { Get(); return true; }
		else if (StartOf(repFol)) return false;
		else {
			SynErr(n);
			while (!(set[syFol][kind] || set[repFol][kind] || set[0][kind])) {
				Get();
				kind = la.kind;
			}
			return StartOf(syFol);
		}
	}
	
	void Phonebook() {
		Phonebook pb = new Phonebook(); 
		while (la.kind == 1) {
			PhonebookEntry e; 
			e = Entry();
			pb.entries.add(e); 
		}
	}

	PhonebookEntry  Entry() {
		PhonebookEntry  result;
		Person p; 
		p = Person();
		result = new PhonebookEntry(p); 
		PhoneNumber n; 
		n = PhoneNumber();
		result.numbers.add(n); 
		while (StartOf(1)) {
			n = PhoneNumber();
			result.numbers.add(n); 
		}
		return result;
	}

	Person  Person() {
		Person  result;
		String lastname; 
		Expect(1);
		lastname = t.val; result = new Person(lastname); 
		Expect(4);
		Expect(1);
		result.firstnames.add(t.val); 
		while (la.kind == 1 || la.kind == 2) {
			if (la.kind == 1) {
				Get();
			} else {
				Get();
			}
			result.firstnames.add(t.val); 
		}
		return result;
	}

	PhoneNumber  PhoneNumber() {
		PhoneNumber  result;
		result = new PhoneNumber(); 
		if (la.kind == 5 || la.kind == 6 || la.kind == 7) {
			if (la.kind == 5) {
				Get();
				result.type = PhoneNumber.Type.HOME; 
			} else if (la.kind == 6) {
				Get();
				result.type = PhoneNumber.Type.OFFICE; 
			} else {
				Get();
				result.type = PhoneNumber.Type.MOBILE; 
			}
		}
		if (la.kind == 8 || la.kind == 9 || la.kind == 11) {
			if (la.kind == 8 || la.kind == 9) {
				if (la.kind == 8) {
					Get();
				} else {
					Get();
				}
				Expect(3);
				result.country = Long.parseLong(t.val); 
				Expect(10);
				Expect(3);
				result.area = Long.parseLong(t.val); 
			} else {
				Get();
				Expect(3);
				result.area = Long.parseLong(t.val); 
			}
		}
		Expect(3);
		result.number.add(Long.parseLong(t.val)); 
		while (la.kind == 3) {
			Get();
			result.number.add(Long.parseLong(t.val)); 
		}
		return result;
	}



	public void Parse() {
		la = new Token();
		la.val = "";		
		Get();
		Phonebook();
		Expect(0);

	}

	private static final boolean[][] set = {
		{T,x,x,x, x,x,x,x, x,x,x,x, x,x},
		{x,x,x,T, x,T,T,T, T,T,x,T, x,x}

	};


	public String ParseErrors(){
			java.io.PrintStream oldStream = System.out;
		
		java.io.OutputStream out = new java.io.ByteArrayOutputStream();
		java.io.PrintStream newStream = new java.io.PrintStream(out);
		
		errors.errorStream = newStream;
		
		Parse();

		String errorStream = out.toString();
		errors.errorStream = oldStream;

		return errorStream;


	}
} // end Parser


class Errors {
	public int count = 0;                                    // number of errors detected
	public java.io.PrintStream errorStream = System.out;     // error messages go to this stream
	public String errMsgFormat = "-- line {0} col {1}: {2}"; // 0=line, 1=column, 2=text
	
	protected void printMsg(int line, int column, String msg) {
		StringBuffer b = new StringBuffer(errMsgFormat);
		int pos = b.indexOf("{0}");
		if (pos >= 0) { b.delete(pos, pos+3); b.insert(pos, line); }
		pos = b.indexOf("{1}");
		if (pos >= 0) { b.delete(pos, pos+3); b.insert(pos, column); }
		pos = b.indexOf("{2}");
		if (pos >= 0) b.replace(pos, pos+3, msg);
		errorStream.println(b.toString());
	}
	
	public void SynErr (int line, int col, int n) {
		String s;
		switch (n) {
			case 0: s = "EOF expected"; break;
			case 1: s = "name expected"; break;
			case 2: s = "nameabbr expected"; break;
			case 3: s = "number expected"; break;
			case 4: s = "\",\" expected"; break;
			case 5: s = "\"home\" expected"; break;
			case 6: s = "\"office\" expected"; break;
			case 7: s = "\"mobile\" expected"; break;
			case 8: s = "\"00\" expected"; break;
			case 9: s = "\"+\" expected"; break;
			case 10: s = "\"(0)\" expected"; break;
			case 11: s = "\"0\" expected"; break;
			case 12: s = "??? expected"; break;
			default: s = "error " + n; break;
		}
		printMsg(line, col, s);
		count++;
	}

	public void SemErr (int line, int col, String s) {	
		printMsg(line, col, s);
		count++;
	}
	
	public void SemErr (String s) {
		errorStream.println(s);
		count++;
	}
	
	public void Warning (int line, int col, String s) {	
		printMsg(line, col, s);
	}
	
	public void Warning (String s) {
		errorStream.println(s);
	}
} // Errors


class FatalError extends RuntimeException {
	public static final long serialVersionUID = 1L;
	public FatalError(String s) { super(s); }
}
